package cn.edu.hactcm.cotroller;

import cn.edu.hactcm.common.R;
import cn.edu.hactcm.dto.DishDto;
import cn.edu.hactcm.entity.Category;
import cn.edu.hactcm.entity.Dish;
import cn.edu.hactcm.entity.DishFlavor;
import cn.edu.hactcm.service.CategoryService;
import cn.edu.hactcm.service.DishFlavorService;
import cn.edu.hactcm.service.DishService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@Slf4j
@RequestMapping("/dish")
public class DishController {

    @Autowired
    private DishService dishService;

    @Autowired
    private CategoryService categoryService;

    @Autowired
    private DishFlavorService dishFlavorService;
    /**
     * 添加菜品，涉及对两张表进行操作，引入新的数据模型Dto同时包含两张表的属性值，可以完美接受浏览器端传输的数据。
     * @param dishDto
     * @return
     */
    @PostMapping
    public R<String> save(@RequestBody DishDto dishDto){
        dishService.saveWithFlavor(dishDto);
        return R.success("添加菜品成功！");
    }

    /**
     * 分页展示菜品管理相关信息（dish表），因该表中存储菜品分类的id,需要菜品分类的名称。
     * @param page
     * @param pageSize
     * @param name
     * @return
     */
    @GetMapping("/page")
    public R<Page<DishDto>> page(int page,int pageSize,String name){

        //准备好数据模型
        Page<Dish> pageInfo = new Page<>(page, pageSize);
        Page<DishDto> dishDtoPage = new Page<>(page, pageSize);

        //将结果集查询出来并封装给pageInfo对象
        LambdaQueryWrapper<Dish> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.like(name != null,Dish::getName,name)
                .orderByDesc(Dish::getUpdateTime);
        pageInfo = dishService.page(pageInfo, queryWrapper);

        //拷贝属性，排除records属性，因为要对该属性进行处理。records是一个List<dish>集合，要增加其中对象的数据<DishDto>
        BeanUtils.copyProperties(pageInfo,dishDtoPage,"records");
        //对List集合进行处理（List<Dish>-->List<DishDto>）
        List<DishDto> listRecords = new ArrayList<>();
        for (Dish record : pageInfo.getRecords()) {
            DishDto dishDto = new DishDto();
            BeanUtils.copyProperties(record,dishDto);
            Category category = categoryService.getById(record.getCategoryId());
            //这里留了个小bug,有些category列数据删除了，导致根据id查找不到记录，导致对象为空。后期解决！！
            if (category != null) dishDto.setCategoryName(category.getName());

            listRecords.add(dishDto);
        }

        //完整封装为Page<DishDto>对象
        dishDtoPage.setRecords(listRecords);

        return R.success(dishDtoPage);
    }

    /**
     *根据id查询菜品信息和对应的口味信息进行页面回显
     * @param id
     * @return
     */
    @GetMapping("/{id}")
    public R<DishDto> get(@PathVariable Long id){
        //查询菜品基本信息
        Dish dish = dishService.getById(id);
        //查询菜品口味信息<List>
        LambdaQueryWrapper<DishFlavor> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(DishFlavor::getDishId,id);
        List<DishFlavor> dishFlavors = dishFlavorService.list(queryWrapper);

//        将相关信息封装为DishDto类，返回给浏览器。
        DishDto dishDto = new DishDto();
        BeanUtils.copyProperties(dish,dishDto);
        dishDto.setFlavors(dishFlavors);
        return R.success(dishDto);
    }

    /**
     *菜品管理修改功能
     * @param dishDto
     * @return
     */
    @Transactional
    @PutMapping
    public R<String> update(@RequestBody DishDto dishDto){
        //对dish表进行更新
        dishService.updateById(dishDto);

        //对dishFlavor表进行刚更新的时候先根据dishId进行删除操作，将有关数据进行删除，因为不确定是要添加还是要删除，所以直接删除重新添加。
        LambdaQueryWrapper<DishFlavor> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(DishFlavor::getDishId,dishDto.getId());
        ////对dishFlavor表进行删除
        dishFlavorService.remove(queryWrapper);
        for (DishFlavor flavor : dishDto.getFlavors()) {
            flavor.setDishId(dishDto.getId());
        }
        //对dishFlavor表进行添加
        dishFlavorService.saveBatch(dishDto.getFlavors());
        return R.success("修改成功");

    }

    /**
     * 分页展示菜品管理相关信息
     * @param dish
     * @return
     */
    /*@GetMapping("/list")
    public R<List<Dish>> list(Dish dish){
        LambdaQueryWrapper<Dish> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(dish.getCategoryId() != null,Dish::getCategoryId,dish.getCategoryId())
                .orderByAsc(Dish::getSort)
                .orderByDesc(Dish::getUpdateTime)
                .eq(Dish::getStatus,1);
        List<Dish> list = dishService.list(queryWrapper);
        return R.success(list);
    }*/

    /**
     * 分页展示菜品管理相关信息&移动端展示分类下的菜品
     * @param dish
     * @return
     */
    @GetMapping("/list")
    public R<List<DishDto>> list(Dish dish){
        //封装条件：
        LambdaQueryWrapper<Dish> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(dish.getCategoryId() != null,Dish::getCategoryId,dish.getCategoryId())
                .eq(dish.getStatus() != null,Dish::getStatus,dish.getStatus())
                .orderByAsc(Dish::getSort).orderByDesc(Dish::getUpdateTime);
        //根据category_id查询该分类对应的所有菜品信息
        List<Dish> dishes = dishService.list(queryWrapper);
        //由于还要向移动端展示菜品的备选口味，所以此处需要查询dish_flavor表，将flavor一并返回给前端，故此封装为DishDto对象。
        List<DishDto> dishDtos = new ArrayList<DishDto>();
        for (Dish dishInfo : dishes) {
//            对象属性值拷贝
            DishDto dishDto = new DishDto();
            BeanUtils.copyProperties(dishInfo,dishDto);
//            根据菜品ID查询对应的口味信息
            LambdaQueryWrapper<DishFlavor> dishFlavorLambdaQueryWrapper = new LambdaQueryWrapper<>();
            dishFlavorLambdaQueryWrapper.eq(DishFlavor::getDishId,dishInfo.getId());
            List<DishFlavor> dishFlavors = dishFlavorService.list(dishFlavorLambdaQueryWrapper);
//            为DishDto对象的flavors属性赋值
            dishDto.setFlavors(dishFlavors);
            dishDtos.add(dishDto);
        }
        return R.success(dishDtos);
    }

}
